var $        = require("jquery"),
    Packir   = require("./Packir"),
    _        = require("./utils/utils"),
    parallel = require("./utils/parallel"),
    _old;

_old = $.fn.packir;

$.fn.packir = function(method, options) {
    var done, initFns;

    if (_.isObject(method)) {
        options = method;
        method = null;
    }

    options = options || {};

    done = options.callback || _.noop;
    options = _.omit(options, "callback");

    initFns = this
        .map(function() {
            var $el = $(this),
                packir;

            if ( !(packir = Packir.find($el)) ) {
                if (method) {
                    throw new Error("Could not call method of non Packired element");
                }

                packir = new Packir($el, options);
            }

            if (method) {
                return function(next) {
                    packir.method(method, options, next);
                }
            }

            return function(next) {
                packir.run(next);
            }
        })
        .toArray();

    parallel(initFns, done);
};

$.fn.packir.noConflict = function() {
    $.fn.packir = _old;
};